<?php
// HTTP statusy https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/


function seznam_zakazniku($db){
  //Z tabulky zakaznic získá informace o všech zakaznicich.
  $stmt = $db->prepare("SELECT zakaznici_id,jmeno, prijmeni, email FROM zakaznici ORDER BY zakaznici_id;");
  $stmt->execute();
  $data='{
  "zakaznici": [';
  if($stmt->rowCount()>0){
   //první zákazník nemá před sebou čárku, proto je odchycen mimo cyklus.
    $zakaznik=$stmt->fetch();
    $data.='
    {"id": '.$zakaznik[0].',
    "jmeno": '.$zakaznik[1].',
    "prijmeni": '.$zakaznik[2].',
    "email": '.$zakaznik[3].'}';
    while($zakaznik=$stmt->fetch()){
      $data.=',
    {"id": '.$zakaznik[0].',
    "jmeno": '.$zakaznik[1].',
    "prijmeni": '.$zakaznik[2].',
    "email": '.$zakaznik[3].'}';
    } 
  }

    $data.='
  ]  
}';
  header("HTTP/1.1 200 OK");
  header('Content-Type: application/json');
  print $data;
}
function zakaznik_info($db,$id){
  header('Content-Type: application/json');
  $stmt = $db->prepare("SELECT zakaznici_id, jmeno, prijmeni, email FROM zakaznici WHERE zakaznici_id=:zakaznici_id;");
  $stmt->bindParam(':zakaznici_id', $id, PDO::PARAM_INT);
  $stmt->execute();
  if($stmt->rowCount()>0){
    $zakaznik=$stmt->fetch();
    header("HTTP/1.1 200 OK");
    print '{
  "zakaznik":{
    "id": '.$zakaznik[0].',
    "jmeno": '.$zakaznik[1].',
    "prijmeni": '.$zakaznik[2].',
    "email": '.$zakaznik[3].'
  }
}';
  }
  else{
    header("HTTP/1.1 404 Not Found");
    exit('{"chyby":[
  {
    "kod_zpravy": -8,
    "text_zpravy": "Zákazník s tímto id neexistuje."
  }]
}');
  }
}


function novy_zakaznik ($db){
  $body = file_get_contents('php://input');
  $zakaznik=json_decode($body,true);
  $chyba="";
  header('Content-Type: application/json');
  if($zakaznik === null) {
    $chyba= '
  {
    "kod_zpravy": -1,
    "text_zpravy": "Nevalidní JSON."
  }';
  }
  else{
    if(! isset($zakaznik['pristupovy_kod']) || $zakaznik['pristupovy_kod']!='xxxxxxxxxxxx'){
      $chyba='
  {
    "kod_zpravy": -2,
    "text_zpravy": "Nepovolený přístup."
  }';
    }
    else{
      if(! isset($zakaznik['jmeno']) || $zakaznik['jmeno']==''){
        $chyba='
  {
    "kod_zpravy": -3,
    "text_zpravy": "Chybí jméno."
  }';
      }
      if(! isset($zakaznik['prijmeni']) || $zakaznik['prijmeni']==''){
        if($chyba!=""){
          $chyba.=',';
        }
        $chyba.='
  {
    "kod_zpravy": -4,
    "text_zpravy": "Chybí příjmení."
  }';
      }
      if(! isset($zakaznik['heslo']) || $zakaznik['heslo']==''){
        if($chyba!=""){
          $chyba .= ',';
        }
        $chyba.='
  {
    "kod_zpravy": -5,
    "text_zpravy": "Chybí heslo."
  }';
      }
      if(! isset($zakaznik['email']) || $zakaznik['email']==''){
        if($chyba!=""){
          $chyba.=',';
        }
        $chyba.='
  {
    "kod_zpravy": -6,
    "text_zpravy": "Chybí e-mail."
  }';
      }
      else{
        if(!filter_var($zakaznik['email'], FILTER_VALIDATE_EMAIL)){
          if($chyba!=""){
            $chyba.=',';
          }
          $chyba.='
  {
    "kod_zpravy": -7,
    "text_zpravy": "E-mail má špatný formát."
  }';
        }
      }
    }
  }
  if($chyba!=''){
    header("HTTP/1.1 400 Bad Request");
    exit('{"chyby":['.$chyba.']
}');
  }
  else{
    $stmt = $db->prepare("SELECT count(*) FROM zakaznici WHERE email=:email;");    
    $stmt->bindParam(':email', $zakaznik['email'], PDO::PARAM_STR);
    $stmt->execute();
    $pocet=$stmt->fetch();
    if($pocet[0]>0){
      header("HTTP/1.1 409 Conflict");
      exit('{"chyby":[
  {
    "kod_zpravy": -8,
    "text_zpravy": "Již existuje zákazník s stejným e-mailem."
  }]
}');
    }
    else{
      $stmt = $db->prepare("INSERT INTO zakaznici (jmeno, prijmeni,email,heslo) VALUES (:jmeno, :prijmeni, :email,:heslo);");
      $stmt->bindParam(':jmeno', $zakaznik['jmeno'], PDO::PARAM_STR);
      $stmt->bindParam(':prijmeni', $zakaznik['prijmeni'], PDO::PARAM_STR);
      $stmt->bindParam(':email', $zakaznik['email'], PDO::PARAM_STR);
      $pass=hash('sha256', md5('datab8ye').$zakaznik['heslo'], false);
      $stmt->bindParam(':heslo', $pass, PDO::PARAM_STR);
      $stmt->execute();
      if ($stmt->rowCount()==1){
        header("HTTP/1.1 201 Created");
        print '{
  "kod_zpravy": 1,
  "text_zpravy": "Zákazník byl vložen."
}';
      }
      else{
        header("HTTP/1.1 200 OK");
        print '{
  "kod_zpravy": 2,
  "text_zpravy": "Zákazník nebyl vložen."
}';
      }
    }
  }    
}

function upravZakaznika($db,$id){
  $body = file_get_contents('php://input');
  $zakaznik=json_decode($body,true);
  $chyba="";
  header('Content-Type: application/json');
  if($zakaznik === null) {
    $chyba= '
  {
    "kod_zpravy": -1,
    "text_zpravy": "Nevalidní JSON."
  }';
  }
  else{
    if((!isset($zakaznik['jmeno']) || $zakaznik['jmeno']=='') and (! isset($zakaznik['prijmeni']) || $zakaznik['prijmeni']=='') and (! isset($zakaznik['heslo']) || $zakaznik['heslo']=='') and (! isset($zakaznik['email']) || $zakaznik['email']=='')){
      $chyba='
  {
    "kod_zpravy": -9,
    "text_zpravy": "Musíte upravovat alespoň jednu položku z  jméno, příjmení, e-mail nebo heslo."
  }';
    }
    else{
      if(isset($zakaznik['email'])  and !filter_var($zakaznik['email'], FILTER_VALIDATE_EMAIL)){
        if($chyba!=""){
          $chyba.=',';
        }
        $chyba.='
  {
    "kod_zpravy": -7,
    "text_zpravy": "E-mail má špatný formát."
  }';
      }
    }
    if(! isset($zakaznik['puvodni_heslo']) || $zakaznik['puvodni_heslo']==''){
      if($chyba!=""){
        $chyba.=',';
      }
      $chyba.='
  {
    "kod_zpravy": -10,
    "text_zpravy": "Nebylo zadáno původní heslo."
  }';
    }
    else{
      $stmt = $db->prepare("SELECT count(*) FROM zakaznici WHERE heslo=:heslo AND zakaznici_id=:zakaznici_id;");    
      $stmt->bindParam(':zakaznici_id', $id, PDO::PARAM_INT);    
      $pass=hash('sha256', md5('datab8ye').$zakaznik['puvodni_heslo'], false);
      $stmt->bindParam(':heslo', $pass, PDO::PARAM_STR);
      $stmt->execute();
      $pocet=$stmt->fetch();
      if($pocet[0]==0){
        if($chyba!=""){
        $chyba.=',';
      }
      $chyba.='
  {
    "kod_zpravy": -11,
    "text_zpravy": "Id zákazníka se neshoduje s původním heslem."
  }';
      }
  }
  if($chyba!=''){
    header("HTTP/1.1 400 Bad Request");
    exit('{"chyby":['.$chyba.']
}');
  }
  else{
    $update="";
    if(isset($zakaznik['jmeno']) and $zakaznik['jmeno']!=''){
      $update="jmeno=:jmeno";
    }
    if(isset($zakaznik['prijmeni']) and $zakaznik['prijmeni']!=''){
      if($update!=""){
        $update.=',';
      }
      $update.="prijmeni=:prijmeni";
    }
    if(isset($zakaznik['email']) and $zakaznik['email']!=''){
      if($update!=""){
        $update.=',';
      }
      $update.="email=:email";
    }
    if(isset($zakaznik['heslo']) and $zakaznik['heslo']!=''){
      if($update!=""){
        $update.=',';
      }
      $update.="heslo=:heslo";
    }
    $update="UPDATE zakaznici SET ".$update." WHERE zakaznici_id=:zakaznici_id;";
    $stmt = $db->prepare($update);
    if(isset($zakaznik['jmeno']) and $zakaznik['jmeno']!=''){
      $stmt->bindParam(':jmeno', $zakaznik['jmeno'], PDO::PARAM_STR);
    }
    if(isset($zakaznik['prijmeni']) and $zakaznik['prijmeni']!=''){
      $stmt->bindParam(':prijmeni', $zakaznik['prijmeni'], PDO::PARAM_STR);
    }
    if(isset($zakaznik['email']) and $zakaznik['email']!=''){
      $stmt->bindParam(':email', $zakaznik['email'], PDO::PARAM_STR);
    }
    if(isset($zakaznik['heslo']) and $zakaznik['heslo']!=''){
      $pass=hash('sha256', md5('datab8ye').$zakaznik['heslo'], false);
      $stmt->bindParam(':heslo', $pass, PDO::PARAM_STR);
    }
    $stmt->bindParam(':zakaznici_id', $id, PDO::PARAM_INT);
    $stmt->execute();
      if ($stmt->rowCount()==1){
        header("HTTP/1.1 200 OK");
        print '{
  "kod_zpravy": 1,
  "text_zpravy": "Zákazník byl upraven."
}';
      }
      else{
        header("HTTP/1.1 200 OK");
        print '{
  "kod_zpravy": 2,
  "text_zpravy": "Zákazník nebyl upraven."
}';
      }
    }
  }    
}


function smazZakaznika($db,$id){
  $body = file_get_contents('php://input');
  $zakaznik=json_decode($body,true);
  $chyba="";
  header('Content-Type: application/json');
  if($zakaznik === null) {
    $chyba= '
  {
    "kod_zpravy": -1,
    "text_zpravy": "Nevalidní JSON."
  }';
  }
  else{
    if(! isset($zakaznik['puvodni_heslo']) || $zakaznik['puvodni_heslo']==''){
      if($chyba!=""){
        $chyba.=',';
      }
      $chyba.='
  {
    "kod_zpravy": -10,
    "text_zpravy": "Nebylo zadáno původní heslo."
  }';
    }
    else{
      $stmt = $db->prepare("SELECT count(*) FROM zakaznici WHERE heslo=:heslo AND zakaznici_id=:zakaznici_id;");    
      $stmt->bindParam(':zakaznici_id', $id, PDO::PARAM_INT);    
      $pass=hash('sha256', md5('datab8ye').$zakaznik['puvodni_heslo'], false);
      $stmt->bindParam(':heslo', $pass, PDO::PARAM_STR);
      $stmt->execute();
      $pocet=$stmt->fetch();
      if($pocet[0]==0){
        if($chyba!=""){
        $chyba.=',';
      }
      $chyba.='
  {
    "kod_zpravy": -11,
    "text_zpravy": "Id zákazníka se neshoduje s původním heslem."
  }';
      }
  }
  if($chyba!=''){
    header("HTTP/1.1 400 Bad Request");
    exit('{"chyby":['.$chyba.']
}');
  }
  else{
    $stmt = $db->prepare("DELETE FROM zakaznici WHERE zakaznici_id=:zakaznici_id");
    $stmt->bindParam(':zakaznici_id', $id, PDO::PARAM_INT);
    $stmt->execute();
      if ($stmt->rowCount()==1){
        header("HTTP/1.1 200 OK");
        print '{
  "kod_zpravy": 1,
  "text_zpravy": "Zákazník byl smazán."
}';
      }
      else{
        header("HTTP/1.1 200 OK");
        print '{
  "kod_zpravy": 2,
  "text_zpravy": "Zákazník nebyl smazán."
}';
      }
    }
  }    
}



?>