<?php
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

require __DIR__ . '/../functions/functions.php'; 

$app = new \Slim\App;
//Hlavni stranka


$app->get('/', function (Request $request, Response $response, array $args) {
    require __DIR__ . '/../html/head.html';
    try{
      print '<h1>Informace k API </h1>
      <h2>GET</h2>
      <ul>
        <li><strong>/zakaznici</strong> &hellip; výpis všech zákazníků.</li>
        <li><strong>/zakaznik/{id}</strong> &hellip; výpis zákazníka s odpovídajícím id.</li>
        <li><strong></strong> &hellip; </li>
      </ul>
      <h2>POST</h2>
      <ul>
        <li><strong>/novyZakaznik</strong> &hellip; přidá nového zákazníka. V těle je potřeba předat JSON obsahující položky jmeno, prijmeni, email a heslo. Např.: <pre>
{
  "pristupovy_kod": "pristupovy_kod",
  "jmeno": "Gregor",
  "prijmeni": "Mendel",
  "email": "gregor.Jmendelu.cz",
  "heslo": "heslo123"
}</pre> </li>
        <li><strong></strong> &hellip; </li>
        <li><strong></strong> &hellip; </li>
      </ul>
      <h2>PUT</h2>
      <ul>
        <li><strong>/upravZakaznika/{id}</strong> &hellip; Upraví zaslaná data o zákazníkovi s uvedeným id. V těle je potřeba předat JSON obsahující položkou puvodni_heslo, k ní je potřeba přidat alespoň měněnou položku z položek jmeno, prijmeni, email a heslo. Např.: <pre>
{
  "puvodni_heslo": "heslo123",
  "heslo": "noveHeslo",
  "jmeno": "Jarmila"
}</pre> </li>
        <li><strong></strong> &hellip; </li>
        <li><strong></strong> &hellip; </li>
      </ul>
      <h2>DELETE</h2>
      <ul>
        <li><strong>/smazZakaznika/{id}</strong> &hellip; Smaže data o zákazníkovi s uvedeným id. V těle je potřeba předat JSON obsahující položkou puvodni_heslo. Např.: <pre>
{
  "puvodni_heslo": "heslo123",
}</pre> </li>
        <li><strong></strong> &hellip; </li>
        <li><strong></strong> &hellip; </li>
      </ul>';
      
      
    }
    catch(PDOException $e){
      print '{"error": {"text": '.$e->getMessage().'}}';
    }
    require __DIR__ . '/../html/foot.html';
});


$app->get('/zakaznici', function (Request $request, Response $response, array $args) {
  $db=new db();
  $db=$db->connect();
  try{
    seznam_zakazniku($db);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});

$app->get('/zakaznik/{id}', function (Request $request, Response $response, array $args) {
  $id = $args['id'];
  $db=new db();
  $db=$db->connect();
  try{
    zakaznik_info($db,$id);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});

$app->post('/novyZakaznik', function (Request $request, Response $response, array $args) {
  try{
    $db=new db();
    $db=$db->connect();
    novy_zakaznik($db);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});

$app->put('/upravZakaznika/{id}', function (Request $request, Response $response, array $args) {
  $id = $args['id'];
  $db=new db();
  $db=$db->connect();
  try{
    upravZakaznika($db,$id);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});
//alternativa určená pro akelu
$app->post('/upravZakaznika/{id}', function (Request $request, Response $response, array $args) {
  $id = $args['id'];
  $db=new db();
  $db=$db->connect();
  try{
    upravZakaznika($db,$id);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});

$app->delete('/smazZakaznika/{id}', function (Request $request, Response $response, array $args) {
  $id = $args['id'];
  $db=new db();
  $db=$db->connect();
  try{
    smazZakaznika($db,$id);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});
//alternativa určená pro akelu
$app->post('/smazZakaznika/{id}', function (Request $request, Response $response, array $args) {
  $id = $args['id'];
  $db=new db();
  $db=$db->connect();
  try{
    smazZakaznika($db,$id);
  }
  catch(PDOException $e){
    header("HTTP/1.1 406 Not Acceptable");
    header('Content-Type: application/json');
    print '{"database_error": {"text": '.$e->getMessage().'}}';
  }
});



$app->get('/hello/{name}', function (Request $request, Response $response, array $args) {
    $name = $args['name'];
    $response->getBody()->write("Ahoj, $name");
    return $response;
});
?>